cbuffer SCALE_OFFSET : register(b0)
{
	float4x4 scaleOffsetMat;
	int isAlphaTested;
	float alphaRef;
};

cbuffer CONSTANT : register(b2)
{
	float4 fc32;
	float4 fc112;
	float4 fc224;
	float4 fc256;
	float4 fc304;
	float4 fc384;
	float4 fc432;
	float4 fc512;
	float4 fc560;
	float4 fc688;
	float4 fc720;
	float4 fc800;
	float4 fc832;
	float4 fc864;
	float4 fc896;
	float4 fc928;
	float4 fc960;
	float4 fc1008;
	float4 fc1040;
	float4 fc1088;
	float4 fc1184;
	float4 fc1216;
	float4 fc1280;
	float4 fc1376;
	float4 fc1408;
	float4 fc1456;
	float4 fc1536;
	float4 fc1600;
	float4 fc1632;
	float4 fc1728;
	float4 fc1760;
	float4 fc1792;
	float4 fc1824;
	float4 fc1872;
	float4 fc1936;
	float4 fc1968;
	float4 fc2000;
	float4 fc2032;
	float4 fc2112;
	float4 fc2176;
	float4 fc2304;
	float4 fc2336;
	float4 fc2368;
	float4 fc2400;
	float4 fc2448;
	float4 fc2496;
	float4 fc2528;
	float4 fc2560;
	float4 fc2640;
	float4 fc2704;
	float4 fc2784;
	float4 fc2848;
	float4 fc2880;
	float4 fc2912;
	float4 fc2960;
	float4 fc3008;
	float4 fc3040;
	float4 fc3072;
	float4 fc3152;
	float4 fc3216;
	float4 fc3296;
	float4 fc3360;
	float4 fc3392;
	float4 fc3424;
	float4 fc3472;
	float4 fc3520;
	float4 fc3552;
	float4 fc3584;
	float4 fc3664;
	float4 fc3728;
	float4 fc3760;
	float4 fc3840;
	float4 fc3904;
	float4 fc3968;
	float4 fc4000;
	float4 fc4048;
	float4 fc4080;
	float4 fc4144;
	float4 fc4192;
	float4 fc4336;
	float4 fc4368;
	float4 fc4400;
	float4 fc4448;
	float4 fc4512;
	float4 fc4544;
	float4 fc4576;
	float4 fc4640;
	float4 fc4672;
	float4 fc4816;
};

Texture2D tex1 : register(t1);
sampler tex1sampler : register(s1);
Texture2D tex0 : register(t0);
sampler tex0sampler : register(s0);
Texture2D tex2 : register(t2);
sampler tex2sampler : register(s2);

struct PixelInput
{
	float4 Position : SV_POSITION;
	float4 diff_color : COLOR0;
	float4 spec_color : COLOR1;
	float4 dst_reg3 : COLOR2;
	float4 dst_reg4 : COLOR3;
	float fogc : FOG;
	float4 tc9 : TEXCOORD9;
	float4 tc0 : TEXCOORD0;
	float4 tc1 : TEXCOORD1;
	float4 tc2 : TEXCOORD2;
	float4 tc3 : TEXCOORD3;
	float4 tc4 : TEXCOORD4;
	float4 tc5 : TEXCOORD5;
	float4 tc6 : TEXCOORD6;
	float4 tc7 : TEXCOORD7;
	float4 tc8 : TEXCOORD8;
};

struct PixelOutput
{
	float4 ocol0 : SV_TARGET0;
	float4 ocol1 : SV_TARGET1;
	float4 ocol2 : SV_TARGET2;
	float4 ocol3 : SV_TARGET3;
};

float4 divsq_legacy(float4 num, float4 denum)
{
	return num / sqrt(max(denum.xxxx, 1.E-10));
}
float4 rcp_legacy(float4 denum)
{
	return 1. / denum;
}
float4 rsq_legacy(float4 val)
{
	return float(1.0 / sqrt(max(val.x, 1.E-10))).xxxx;
}

float4 log2_legacy(float4 val)
{
	return log2(max(val.x, 1.E-10)).xxxx;
}

float4 lit_legacy(float4 val){
	float4 clamped_val = val;
	clamped_val.x = max(val.x, 0);
	clamped_val.y = max(val.y, 0);
	float4 result;
	result.x = 1.0;
	result.w = 1.;
	result.y = clamped_val.x;
	result.z = clamped_val.x > 0.0 ? exp(clamped_val.w * log(max(clamped_val.y, 1.E-10))) : 0.0;
	return result;
}

void ps_impl(bool is_front_face, PixelInput In, inout float4 r0, inout float4 h0, inout float4 r1, inout float4 h2, inout float4 r2, inout float4 h4, inout float4 r3, inout float4 h6, inout float4 r4, inout float4 h8)
{
	float4 tc3 = In.tc3;
	float4 tc1 = In.tc1;
	float4 tc5 = In.tc5;
	float4 tc0 = In.tc0;
	float4 tc2 = In.tc2;
	float4 tc4 = In.tc4;
	float4 tc6 = In.tc6;
	float4 tc7 = In.tc7;
	float4 tc8 = In.tc8;
	float4 tc9 = In.tc9;
	float4 gl_FragCoord = In.Position;
	gl_FragCoord.y = (512 - gl_FragCoord.y);
	float4 ssa = is_front_face ? float4(1., 1., 1., 1.) : float4(-1., -1., -1., -1.);
	float4 h10 = float4(0., 0., 0., 0.);
	float4 h9 = float4(0., 0., 0., 0.);
	float4 cc0 = float4(0., 0., 0., 0.);
	float4 h11 = float4(0., 0., 0., 0.);
	float4 h1 = float4(0., 0., 0., 0.);
	float4 r5 = float4(0., 0., 0., 0.);
	float2  tex1_scale = float2(1., 1.);
	float2  tex0_scale = float2(1., 1.);
	float2  tex2_scale = float2(1., 1.);
	r0.xy = gl_FragCoord.xy;
	r1.w = (-r0.yyyy + fc32.xxxx).w;
	r1.z = r0.xxxx.z;
	r0 = tc3;
	h0.xy = (r0 + -r1.zwzz).xy;
	h0.z = fc112.xxxx.z;
	h10.xyz = (h0 * r0.zzzz).xyz;
	h9.w = h10.zzzz.w;
	h8.x = dot(h10.xyz, h10.xyz).xxxx.x;
	h0.x = divsq_legacy(abs(h8), h8).x;
	h0.y = dot(h10.xy, h10.xy).xxxx.y;
	h0.w = (-h0.yyyy + fc224.xxxx).w;
	r4.xyz = fc256.yxyx.xyz;
	r2 = tc1;
	cc0.x = float4((h0 > fc304.xxxx)).x;
	if ((cc0.xxxx == float4(0., 0., 0., 0.)).x) h9.w = divsq_legacy(abs(h0), h0.wwww).w;
	h11.xyz = (h9.wwww * r2).xyz;
	r3 = tc5;
	h10.w = float4((r3 > fc384.xxxx)).w;
	r1 = tc0;
	h9.w = float4((r3 > fc432.xxxx)).w;
	h2.xyz = (h10.xxxx * r1 + h11).xyz;
	r0.xyz = tc2.xyz;
	h2.xyz = (h10.yyyy * r0 + h2).xyz;
	h0.w = float4((h10 == fc512.xxxx)).w;
	h0.xyz = normalize(h2).xyz;
	h11.w = float4((h9 == fc560.xxxx)).w;
	h1.x = min(abs(h0), abs(h0.yyyy)).x;
	cc0.z = (h11.wwww * h10.wwww).z;
	cc0.x = (h11.wwww * h0.wwww).x;
	h0.w = max(abs(h0.xxxx), abs(h0.yyyy)).w;
	cc0.w = h0.xxxx.w;
	h1.x = (h1 / h0.wwww.xxxx).x;
	if ((cc0.zzzz == float4(0., 0., 0., 0.)).x) r4.xyz.x = fc688.xxyy.xyz.x;
	if ((cc0.zzzz == float4(0., 0., 0., 0.)).y) r4.xyz.y = fc688.xxyy.xyz.y;
	if ((cc0.zzzz == float4(0., 0., 0., 0.)).z) r4.xyz.z = fc688.xxyy.xyz.z;
	h0.w = (-abs(h0.zzzz) + fc720.yyyy).w;
	h1.y = rsq_legacy(h0.wwww).y;
	h2.x = (h1 * h1).x;
	cc0.z = float4((abs(h0.yyyy) > abs(h0.xxxx))).z;
	h0.x = (abs(h0.zzzz) * fc800.xxxx + fc800.yyyy).x;
	h0.w = (h2.xxxx * fc832.xxxx + fc832.yyyy).w;
	h0.x = (abs(h0.zzzz) * h0 + fc864.zzzz).x;
	h0.w = (h0 * h2.xxxx + fc896.xxxx).w;
	h0.x = (abs(h0.zzzz) * h0 + fc928.yyyy).x;
	h0.w = (h0 * h2.xxxx + fc960.xxxx).w;
	h0.x = (h0 / h1.yyyy.xxxx).x;
	if ((cc0.xxxx != float4(0., 0., 0., 0.)).x) r4.xyz.x = fc1008.xyyx.xyz.x;
	if ((cc0.xxxx != float4(0., 0., 0., 0.)).y) r4.xyz.y = fc1008.xyyx.xyz.y;
	if ((cc0.xxxx != float4(0., 0., 0., 0.)).z) r4.xyz.z = fc1008.xyyx.xyz.z;
	h0.w = (h0 * h2.xxxx + fc1040.zzzz).w;
	h1.y = (h0.wwww * h2.xxxx).y;
	h0.w = float4((h0.zzzz < fc1088.xxxx)).w;
	h2.w = ((h0 * h0.xxxx) * 2.0).w;
	h1.x = (h1.yyyy * h1 + h1).x;
	h0.x = (h0 + -h2.wwww).x;
	h2.w = h1.xxxx.w;
	if ((cc0.zzzz != float4(0., 0., 0., 0.)).x) h2.w = (-h1.xxxx + fc1184.xxxx).w;
	h2.x = ((h0.wwww * fc1216.yyyy + h0) / 2.0).x;
	h2.y = h2.wwww.y;
	h2.x = cos(h2.xxxx).x;
	if ((cc0.wwww < float4(0., 0., 0., 0.)).x) h2.y = (-h2.wwww + fc1280.xxxx).y;
	cc0.x = -h0.yyyy.x;
	h2.z = h2.yyyy.z;
	h0.x = ((h2 * h2) * 2.0).x;
	if ((cc0.xxxx < float4(0., 0., 0., 0.)).x) h2.z = -h2.yyyy.z;
	h0.x = (-h0 + fc1376.xxxx).x;
	h2.z = (-h2 * fc1408.yyyy).z;
	h2.w = -h0.xxxx.w;
	r0.xy = (h2.zwzz * fc1456.xyxx + r3).xy;
	r0.xyz = tex1.Sample(tex1sampler, r0.xy * tex1_scale).xyz;
	r2.xyz = (r4.yyyy * r0).xyz;
	r1.xy = r1.xy;
	r0.xy = (h2.zwzz * fc1536.xyxx + r3).xy;
	r0.xyz = tex0.Sample(tex0sampler, r0.xy * tex0_scale).xyz;
	r2.xyz = (r4.xxxx * r0 + r2).xyz;
	r5.xyz = fc1600.xyxx.xyz;
	r0.xy = (h2.zwzz * fc1632.xyxx + r3).xy;
	r3.xyw = (r0.xyzz * r4.zzzz + r2.xyzz).xyw;
	r4 = tc4;
	h11.w = float4((r4 > fc1728.xxxx)).w;
	h0.w = float4((r4 > fc1760.zzzz)).w;
	r1.xz = (h2.zzww * fc1792.xxyy + r4.xxyy).xz;
	h0.x = float4((h0.wwww == fc1824.xxxx)).x;
	r2.xyz = (r3.xywz * r3.zzzz).xyz;
	h11.w = float4((h11 == fc1872.xxxx)).w;
	cc0.x = (h11.wwww * h0).x;
	cc0.w = (h11 * h0).w;
	if ((cc0.wwww == float4(0., 0., 0., 0.)).x) r5.xyz.x = fc1936.xxyy.xyz.x;
	if ((cc0.wwww == float4(0., 0., 0., 0.)).y) r5.xyz.y = fc1936.xxyy.xyz.y;
	if ((cc0.wwww == float4(0., 0., 0., 0.)).z) r5.xyz.z = fc1936.xxyy.xyz.z;
	h11.w = float4((r0 > fc1968.zzzz)).w;
	if ((cc0.xxxx != float4(0., 0., 0., 0.)).x) r5.xyz.x = fc2000.xyyx.xyz.x;
	if ((cc0.xxxx != float4(0., 0., 0., 0.)).y) r5.xyz.y = fc2000.xyyx.xyz.y;
	if ((cc0.xxxx != float4(0., 0., 0., 0.)).z) r5.xyz.z = fc2000.xyyx.xyz.z;
	h9.w = float4((r0 > fc2032.zzzz)).w;
	r0.xyz = tex1.Sample(tex1sampler, r1.xzzw.xy * tex1_scale).xyz;
	r3.xyz = (r5.yyyy * r0).xyz;
	r1.xy = r1.xy;
	r0.xy = (h2.zwzz * fc2112.xyxx + r4).xy;
	r0.xyz = tex0.Sample(tex0sampler, r0.xy * tex0_scale).xyz;
	r3.xyz = (r5.xxxx * r0 + r3).xyz;
	r0.xy = (h2.zwzz * fc2176.xyxx + r4).xy;
	r3.xyz = (r0 * r5.zzzz + r3).xyz;
	r3.xyz = r3.xyz;
	r2.xyz = (r3 * r4.zzzz + r2).xyz;
	r3 = tc6;
	h0.x = float4((r3.wwww > fc2304.xxxx)).x;
	h0.w = float4((r3 > fc2336.yyyy)).w;
	h0.w = float4((h0 == fc2368.xxxx)).w;
	r4.xyz = fc2400.xyxx.xyz;
	cc0.x = (h0.wwww * h0).x;
	h1.w = float4((h0.xxxx == fc2448.xxxx)).w;
	cc0.w = (h0 * h1).w;
	if ((cc0.xxxx == float4(0., 0., 0., 0.)).x) r4.xyz.x = fc2496.xxyy.xyz.x;
	if ((cc0.xxxx == float4(0., 0., 0., 0.)).y) r4.xyz.y = fc2496.xxyy.xyz.y;
	if ((cc0.xxxx == float4(0., 0., 0., 0.)).z) r4.xyz.z = fc2496.xxyy.xyz.z;
	if ((cc0.wwww != float4(0., 0., 0., 0.)).x) r4.xyz.x = fc2528.xyyx.xyz.x;
	if ((cc0.wwww != float4(0., 0., 0., 0.)).y) r4.xyz.y = fc2528.xyyx.xyz.y;
	if ((cc0.wwww != float4(0., 0., 0., 0.)).z) r4.xyz.z = fc2528.xyyx.xyz.z;
	r0.xy = (h2.zwzz * fc2560.xyxx + r3).xy;
	r0.xyz = tex1.Sample(tex1sampler, r0.xy * tex1_scale).xyz;
	r5.xyz = (r4.yyyy * r0).xyz;
	r1.xy = r1.xy;
	r0.xy = (h2.zwzz * fc2640.xyxx + r3).xy;
	r0.xyz = tex0.Sample(tex0sampler, r0.xy * tex0_scale).xyz;
	r5.xyz = (r4.xxxx * r0 + r5).xyz;
	r0.xy = (h2.zwzz * fc2704.xyxx + r3).xy;
	r3.xyw = (r0.xyzz * r4.zzzz + r5.xyzz).xyw;
	r4.xyz = fc2784.xyxx.xyz;
	r2.xyz = (r3.xywz * r3.zzzz + r2).xyz;
	r3 = tc7;
	h0.x = float4((r3.wwww > fc2848.xxxx)).x;
	h0.w = float4((r3 > fc2880.yyyy)).w;
	h0.w = float4((h0 == fc2912.xxxx)).w;
	cc0.x = (h0.wwww * h0).x;
	h1.w = float4((h0.xxxx == fc2960.xxxx)).w;
	cc0.w = (h0 * h1).w;
	if ((cc0.xxxx == float4(0., 0., 0., 0.)).x) r4.xyz.x = fc3008.xxyy.xyz.x;
	if ((cc0.xxxx == float4(0., 0., 0., 0.)).y) r4.xyz.y = fc3008.xxyy.xyz.y;
	if ((cc0.xxxx == float4(0., 0., 0., 0.)).z) r4.xyz.z = fc3008.xxyy.xyz.z;
	if ((cc0.wwww != float4(0., 0., 0., 0.)).x) r4.xyz.x = fc3040.xyyx.xyz.x;
	if ((cc0.wwww != float4(0., 0., 0., 0.)).y) r4.xyz.y = fc3040.xyyx.xyz.y;
	if ((cc0.wwww != float4(0., 0., 0., 0.)).z) r4.xyz.z = fc3040.xyyx.xyz.z;
	r0.xy = (h2.zwzz * fc3072.xyxx + r3).xy;
	r0.xyz = tex1.Sample(tex1sampler, r0.xy * tex1_scale).xyz;
	r5.xyz = (r4.yyyy * r0).xyz;
	r1.xy = r1.xy;
	r0.xy = (h2.zwzz * fc3152.xyxx + r3).xy;
	r0.xyz = tex0.Sample(tex0sampler, r0.xy * tex0_scale).xyz;
	r5.xyz = (r4.xxxx * r0 + r5).xyz;
	r0.xy = (h2.zwzz * fc3216.xyxx + r3).xy;
	r3.xyw = (r0.xyzz * r4.zzzz + r5.xyzz).xyw;
	r4.xyz = fc3296.xyxx.xyz;
	r2.xyz = (r3.xywz * r3.zzzz + r2).xyz;
	r3 = tc8;
	h0.x = float4((r3.wwww > fc3360.xxxx)).x;
	h0.w = float4((r3 > fc3392.yyyy)).w;
	h0.w = float4((h0 == fc3424.xxxx)).w;
	cc0.x = (h0.wwww * h0).x;
	h1.w = float4((h0.xxxx == fc3472.xxxx)).w;
	cc0.w = (h0 * h1).w;
	if ((cc0.xxxx == float4(0., 0., 0., 0.)).x) r4.xyz.x = fc3520.xxyy.xyz.x;
	if ((cc0.xxxx == float4(0., 0., 0., 0.)).y) r4.xyz.y = fc3520.xxyy.xyz.y;
	if ((cc0.xxxx == float4(0., 0., 0., 0.)).z) r4.xyz.z = fc3520.xxyy.xyz.z;
	if ((cc0.wwww != float4(0., 0., 0., 0.)).x) r4.xyz.x = fc3552.xyyx.xyz.x;
	if ((cc0.wwww != float4(0., 0., 0., 0.)).y) r4.xyz.y = fc3552.xyyx.xyz.y;
	if ((cc0.wwww != float4(0., 0., 0., 0.)).z) r4.xyz.z = fc3552.xyyx.xyz.z;
	r0.xy = (h2.zwzz * fc3584.xyxx + r3).xy;
	r0.xyz = tex1.Sample(tex1sampler, r0.xy * tex1_scale).xyz;
	r5.xyz = (r4.yyyy * r0).xyz;
	r1.xy = r1.xy;
	r0.zw = (h2 * fc3664.xxxy + r3.xxxy).zw;
	r0.xyz = tex0.Sample(tex0sampler, r0.zwzz.xy * tex0_scale).xyz;
	r5.xyz = (r4.xxxx * r0 + r5).xyz;
	h8.x = float4((h9.wwww == fc3728.xxxx)).x;
	h8.w = float4((h11 == fc3760.xxxx)).w;
	cc0.x = (h8 * h11.wwww).x;
	cc0.w = (h8.xxxx * h8).w;
	r1.xy = r1.xy;
	r0.zw = (h2 * fc3840.xxxy + r3.xxxy).zw;
	r0.xyz = tex2.Sample(tex2sampler, r0.zwzz.xy * tex2_scale).xyz;
	r3.xyw = (r0.xyzz * r4.zzzz + r5.xyzz).xyw;
	r5.xyz = fc3904.xyxx.xyz;
	r4.w = r2.w;
	r4.z = r1.wwww.z;
	r1.xzw = fc3968.xxyx.xzw;
	if ((cc0.xxxx == float4(0., 0., 0., 0.)).x) r1.xzw.x = fc4000.xxxy.xzw.x;
	if ((cc0.xxxx == float4(0., 0., 0., 0.)).y) r1.xzw.y = fc4000.xxxy.xzw.y;
	if ((cc0.xxxx == float4(0., 0., 0., 0.)).z) r1.xzw.z = fc4000.xxxy.xzw.z;
	r2.xyz = (r3.xywz * r3.zzzz + r2).xyz;
	if ((cc0.wwww != float4(0., 0., 0., 0.)).x) r1.xzw.x = fc4048.xxyy.xzw.x;
	if ((cc0.wwww != float4(0., 0., 0., 0.)).y) r1.xzw.y = fc4048.xxyy.xzw.y;
	if ((cc0.wwww != float4(0., 0., 0., 0.)).z) r1.xzw.z = fc4048.xxyy.xzw.z;
	r0.xy = (h2.zwzz * fc4080.xyxx + r4.zwzz).xy;
	r0.xyz = tex1.Sample(tex1sampler, r0.xy * tex1_scale).xyz;
	r3.xyz = (r1.zzzz * r0).xyz;
	r0.xy = (h2.zwzz * fc4144.xyxx + r4.zwzz).xy;
	r0.xyz = tex2.Sample(tex2sampler, r0.xy * tex2_scale).xyz;
	r4.xy = (h2.zwzz * fc4192.xyxx + r4.zwzz).xy;
	r4.xyz = tex0.Sample(tex0sampler, r4.xy * tex0_scale).xyz;
	r4.xyz = (r1.xxxx * r4 + r3).xyz;
	r3.xyw = tc9.xyw;
	r1.w = r1.w;
	r4.xyz = r4.xyz;
	r4.xyz = (r0 * r1.wwww + r4).xyz;
	h9.w = float4((r3 > fc4336.xxxx)).w;
	h0.x = float4((r3.wwww > fc4368.xxxx)).x;
	h0.w = float4((h9 == fc4400.xxxx)).w;
	cc0.x = (h0.wwww * h0).x;
	h1.w = float4((h0.xxxx == fc4448.xxxx)).w;
	cc0.w = (h0 * h1).w;
	r0.w = tc2.w;
	if ((cc0.xxxx == float4(0., 0., 0., 0.)).x) r5.xyz.x = fc4512.xxyy.xyz.x;
	if ((cc0.xxxx == float4(0., 0., 0., 0.)).y) r5.xyz.y = fc4512.xxyy.xyz.y;
	if ((cc0.xxxx == float4(0., 0., 0., 0.)).z) r5.xyz.z = fc4512.xxyy.xyz.z;
	if ((cc0.wwww != float4(0., 0., 0., 0.)).x) r5.xyz.x = fc4544.xyyx.xyz.x;
	if ((cc0.wwww != float4(0., 0., 0., 0.)).y) r5.xyz.y = fc4544.xyyx.xyz.y;
	if ((cc0.wwww != float4(0., 0., 0., 0.)).z) r5.xyz.z = fc4544.xyyx.xyz.z;
	r0.xy = (h2.zwzz * fc4576.xyxx + r3).xy;
	r0.xyz = tex1.Sample(tex1sampler, r0.xy * tex1_scale).xyz;
	r0.xyz = (r5.yyyy * r0).xyz;
	r5.yw = (h2.zzww * fc4640.xxyy + r3.xxyy).yw;
	r1.xy = (h2.zwzz * fc4672.xyxx + r3).xy;
	r1.xyz = tex0.Sample(tex0sampler, r1.xy * tex0_scale).xyz;
	r0.xyz = (r5.xxxx * r1 + r0).xyz;
	r1.xyz = tex2.Sample(tex2sampler, r5.ywzw.xy * tex2_scale).xyz;
	r0.xyz = (r1 * r5.zzzz + r0).xyz;
	r1.z = tc9.z;
	r0.xyz = (r0 * r1.zzzz + r2).xyz;
	r0.xyz = (r4 * r0.wwww + r0).xyz;
	r0.w = fc4816.xxxx.w;

}

PixelOutput main(PixelInput In, bool is_front_face : SV_IsFrontFace)
{
	float4 r0 = float4(0., 0., 0., 0.);
	float4 r1 = float4(0., 0., 0., 0.);
	float4 r2 = float4(0., 0., 0., 0.);
	float4 r3 = float4(0., 0., 0., 0.);
	float4 r4 = float4(0., 0., 0., 0.);
	float4 h0 = float4(0., 0., 0., 0.);
	float4 h2 = float4(0., 0., 0., 0.);
	float4 h4 = float4(0., 0., 0., 0.);
	float4 h6 = float4(0., 0., 0., 0.);
	float4 h8 = float4(0., 0., 0., 0.);
	ps_impl(is_front_face, In, r0, h0, r1, h2, r2, h4, r3, h6, r4, h8);
	PixelOutput Out = (PixelOutput)0;
	Out.ocol0 = r0;
	Out.ocol1 = r2;
	Out.ocol2 = r3;
	Out.ocol3 = r4;
	if (isAlphaTested && Out.ocol0.a <= alphaRef) discard;
	return Out;
}
