cbuffer SCALE_OFFSET : register(b0)
{
	float4x4 scaleOffsetMat;
	int isAlphaTested;
	float alphaRef;
};

cbuffer CONSTANT : register(b2)
{
	float4 fc32;
	float4 fc64;
	float4 fc96;
	float4 fc144;
	float4 fc176;
	float4 fc224;
	float4 fc272;
	float4 fc320;
	float4 fc352;
	float4 fc400;
	float4 fc432;
	float4 fc464;
	float4 fc544;
	float4 fc592;
	float4 fc640;
	float4 fc736;
	float4 fc832;
	float4 fc864;
	float4 fc896;
	float4 fc944;
	float4 fc976;
	float4 fc1008;
	float4 fc1056;
	float4 fc1104;
	float4 fc1248;
	float4 fc1328;
	float4 fc1376;
	float4 fc1440;
	float4 fc1504;
	float4 fc1536;
	float4 fc1568;
	float4 fc1664;
};

Texture2D tex3 : register(t3);
sampler tex3sampler : register(s3);
Texture2D tex4 : register(t4);
sampler tex4sampler : register(s4);
Texture2D tex5 : register(t5);
sampler tex5sampler : register(s5);
Texture2D tex6 : register(t6);
sampler tex6sampler : register(s6);
Texture2D tex1 : register(t1);
sampler tex1sampler : register(s1);
Texture2D tex0 : register(t0);
sampler tex0sampler : register(s0);
Texture2D tex7 : register(t7);
sampler tex7sampler : register(s7);
TextureCube tex2 : register(t2);
sampler tex2sampler : register(s2);
TextureCube tex8 : register(t8);
sampler tex8sampler : register(s8);

struct PixelInput
{
	float4 Position : SV_POSITION;
	float4 diff_color : COLOR0;
	float4 spec_color : COLOR1;
	float4 dst_reg3 : COLOR2;
	float4 dst_reg4 : COLOR3;
	float fogc : FOG;
	float4 tc9 : TEXCOORD9;
	float4 tc0 : TEXCOORD0;
	float4 tc1 : TEXCOORD1;
	float4 tc2 : TEXCOORD2;
	float4 tc3 : TEXCOORD3;
	float4 tc4 : TEXCOORD4;
	float4 tc5 : TEXCOORD5;
	float4 tc6 : TEXCOORD6;
	float4 tc7 : TEXCOORD7;
	float4 tc8 : TEXCOORD8;
};

struct PixelOutput
{
	float4 ocol0 : SV_TARGET0;
	float4 ocol1 : SV_TARGET1;
	float4 ocol2 : SV_TARGET2;
	float4 ocol3 : SV_TARGET3;
};

float4 divsq_legacy(float4 num, float4 denum)
{
	return num / sqrt(max(denum.xxxx, 1.E-10));
}
float4 rcp_legacy(float4 denum)
{
	return 1. / denum;
}
float4 rsq_legacy(float4 val)
{
	return float(1.0 / sqrt(max(val.x, 1.E-10))).xxxx;
}

float4 log2_legacy(float4 val)
{
	return log2(max(val.x, 1.E-10)).xxxx;
}

float4 lit_legacy(float4 val){
	float4 clamped_val = val;
	clamped_val.x = max(val.x, 0);
	clamped_val.y = max(val.y, 0);
	float4 result;
	result.x = 1.0;
	result.w = 1.;
	result.y = clamped_val.x;
	result.z = clamped_val.x > 0.0 ? exp(clamped_val.w * log(max(clamped_val.y, 1.E-10))) : 0.0;
	return result;
}

void ps_impl(bool is_front_face, PixelInput In, inout float4 r0, inout float4 h0, inout float4 r1, inout float4 h2, inout float4 r2, inout float4 h4, inout float4 r3, inout float4 h6, inout float4 r4, inout float4 h8)
{
	float4 tc0 = In.tc0;
	float4 tc1 = In.tc1;
	float4 tc2 = In.tc2;
	float4 tc4 = In.tc4;
	float4 tc3 = In.tc3;
	float4 tc5 = In.tc5;
	float4 tc6 = In.tc6;
	float4 gl_FragCoord = In.Position;
	gl_FragCoord.y = (720 - gl_FragCoord.y);
	float4 ssa = is_front_face ? float4(1., 1., 1., 1.) : float4(-1., -1., -1., -1.);
	float4 h1 = float4(0., 0., 0., 0.);
	float4 r5 = float4(0., 0., 0., 0.);
	float4 h3 = float4(0., 0., 0., 0.);
	float4 cc0 = float4(0., 0., 0., 0.);
	float2  tex3_scale = float2(1., 1.);
	float2  tex4_scale = float2(1., 1.);
	float2  tex5_scale = float2(1., 1.);
	float2  tex6_scale = float2(1., 1.);
	float2  tex1_scale = float2(1., 1.);
	float2  tex0_scale = float2(1., 1.);
	float2  tex7_scale = float2(1., 1.);
	r2 = tc0;
	r1.xyz = (r2.zzzz * fc32).xyz;
	r1.xyz = (r2.yyyy * fc64 + r1).xyz;
	r1.xyz = (r2.wwww * fc96 + r1).xyz;
	r0.yw = tex3.Sample(tex3sampler, tc1.zwzz.xy * tex3_scale).yw;
	h1.xy = (r0.wyzw * fc144.xxxx + fc144.yyyy).xy;
	h1.z = fc176.z;
	r3.yw = tex4.Sample(tex4sampler, tc1.xy * tex4_scale).yw;
	h0.xy = (r3.wyzw * fc224.xxxx + fc224.yyyy).xy;
	h0.z = dot(h1.xyz, h1.xyz).xxxx.z;
	r1.yzw = (r1.xxyz + fc272.xxyz).yzw;
	h1.xy = divsq_legacy(h1, h0.zzzz).xy;
	h0.z = fc320.xxxx.z;
	r3 = (r1.zzzz * fc352);
	h0.z = dot(h0.xyz, h0.xyz).xxxx.z;
	r3 = (r1.yyyy * fc400 + r3);
	r3 = (r1.wwww * fc432 + r3);
	r3 = (r3 + fc464);
	h0.xy = divsq_legacy(h0, h0.zzzz).xy;
	r0.z = r0.z;
	r2.zw = (h1.xxxy + h0.xxxy).zw;
	r2.zw = (r2 * fc544.xxxx).zw;
	r4.xy = tex5.Sample(tex5sampler, (r3.xy / r3.w) * tex5_scale).xy;
	r4.xy = (r4 * fc592.xxxx + fc592.yyyy).xy;
	r0.x = dot(r4.xy, r4.xy).xxxx.x;
	r1.x = (-r0 + fc640.xxxx).x;
	r0.zw = (r3.xxxy + r2).zw;
	r5.xy = gl_FragCoord.xy;
	r0.xy = (r0.zwzz / r3.wwww.xxxx).xy;
	r0.xyz = tex6.Sample(tex6sampler, r0.xy * tex6_scale).xyz;
	r0.xyz = (r0 * fc736.xxxx + fc736.yyyy).xyz;
	r4.z = divsq_legacy(abs(r1.xxxx), r1).z;
	r4.w = dot(r1.yzww.xyz, r4.xyz).xxxx.w;
	r1.yw = tex1.Sample(tex1sampler, tc2.xy * tex1_scale).yw;
	r0.xyz = floor(r0).xyz;
	r1.x = dot(r0.xyz, fc832.xyz).xxxx.x;
	h3.xy = (r1.wyzw * fc864.xxxx + fc864.yyyy).xy;
	h3.z = fc896.z;
	h3.xyz = normalize(h3).xyz;
	r0 = (r5.yyyy * fc944);
	r0 = (r5.xxxx * fc976 + r0);
	r0 = (r1.xxxx * fc1008 + r0);
	r5.xyz = (h3.yyyy * tc4).xyz;
	r0 = (r0 + fc1056);
	r0.xyz = (r0 / r0.wwww.xxxx).xyz;
	r0.w = fc1104.xxxx.w;
	r1.xyz = (h3.xxxx * tc3 + r5).xyz;
	r1.xyz = (h3.zzzz * tc5 + r1).xyz;
	r1.w = dot(r0, r4).xxxx.w;
	r4.xyz = tc6.xyz;
	r0.x = dot(r1.xyz, r1.xyz).xxxx.x;
	cc0.w = float4((r1 < fc1248.xxxx)).w;
	r0.xyz = divsq_legacy(r1, r0).xyz;
	r0.w = (dot(r0.xyz, r4.xyz).xxxx * 2.0).w;
	r0.xyz = (-r0 * r0.wwww + r4).xyz;
	if ((cc0.wwww == float4(0., 0., 0., 0.)).x) r2.zw.x = fc1328.xxxx.zw.x;
	if ((cc0.wwww == float4(0., 0., 0., 0.)).y) r2.zw.y = fc1328.xxxx.zw.y;
	r0.xyz = tex2.Sample(tex2sampler, -r0.xyz).xyz;
	r4.xyz = (r0 * fc1376.xxxx).xyz;
	r0 = tex0.Sample(tex0sampler, tc2.xy * tex0_scale);
	r3.xy = (r3 + r2.zwzz).xy;
	r0.w = (r0 * fc1440.xxxx).w;
	r3.xyz = tex7.Sample(tex7sampler, (r3.xy / r3.w) * tex7_scale).xyz;
	r4.xyz = (r4 * r3).xyz;
	r3.xyz = (r4 * fc1504.xxxx + r3).xyz;
	r3.xyz = (r3 * fc1536).xyz;
	r1.w = (r2.xxxx * fc1568).w;
	r1.xyz = tex8.Sample(tex8sampler, r1.xyz).xyz;
	r1.xyz = (r0 * r1 + r3).xyz;
	r0.xyz = r0.xyz;
	r1.xyz = (r0 * r1 + r3).xyz;
	r0.xyz = (-r1 + fc1664).xyz;
	r0.xyz = (r1.wwww * r0 + r1).xyz;

}

PixelOutput main(PixelInput In, bool is_front_face : SV_IsFrontFace)
{
	float4 r0 = float4(0., 0., 0., 0.);
	float4 r1 = float4(0., 0., 0., 0.);
	float4 r2 = float4(0., 0., 0., 0.);
	float4 r3 = float4(0., 0., 0., 0.);
	float4 r4 = float4(0., 0., 0., 0.);
	float4 h0 = float4(0., 0., 0., 0.);
	float4 h2 = float4(0., 0., 0., 0.);
	float4 h4 = float4(0., 0., 0., 0.);
	float4 h6 = float4(0., 0., 0., 0.);
	float4 h8 = float4(0., 0., 0., 0.);
	ps_impl(is_front_face, In, r0, h0, r1, h2, r2, h4, r3, h6, r4, h8);
	PixelOutput Out = (PixelOutput)0;
	Out.ocol0 = r0;
	Out.ocol1 = r2;
	Out.ocol2 = r3;
	Out.ocol3 = r4;
	if (isAlphaTested && Out.ocol0.a <= alphaRef) discard;
	return Out;
}
