cbuffer SCALE_OFFSET : register(b0)
{
	float4x4 scaleOffsetMat;
	int isAlphaTested;
	float alphaRef;
};

cbuffer CONSTANT : register(b2)
{
	float4 fc32;
	float4 fc64;
	float4 fc112;
	float4 fc144;
	float4 fc192;
	float4 fc240;
	float4 fc272;
	float4 fc368;
	float4 fc400;
	float4 fc432;
	float4 fc496;
	float4 fc528;
	float4 fc560;
	float4 fc608;
	float4 fc768;
	float4 fc800;
	float4 fc864;
	float4 fc896;
	float4 fc928;
	float4 fc960;
	float4 fc992;
	float4 fc1104;
	float4 fc1168;
	float4 fc1200;
	float4 fc1264;
	float4 fc1312;
	float4 fc1424;
	float4 fc1456;
	float4 fc1504;
	float4 fc1536;
	float4 fc1584;
	float4 fc1632;
	float4 fc1664;
	float4 fc1696;
	float4 fc1760;
};

Texture2D tex0 : register(t0);
sampler tex0sampler : register(s0);
Texture2D tex1 : register(t1);
sampler tex1sampler : register(s1);
Texture2D tex3 : register(t3);
sampler tex3sampler : register(s3);
Texture2D tex4 : register(t4);
sampler tex4sampler : register(s4);
Texture2D tex5 : register(t5);
sampler tex5sampler : register(s5);
TextureCube tex2 : register(t2);
sampler tex2sampler : register(s2);
TextureCube tex6 : register(t6);
sampler tex6sampler : register(s6);

struct PixelInput
{
	float4 Position : SV_POSITION;
	float4 diff_color : COLOR0;
	float4 spec_color : COLOR1;
	float4 dst_reg3 : COLOR2;
	float4 dst_reg4 : COLOR3;
	float fogc : FOG;
	float4 tc9 : TEXCOORD9;
	float4 tc0 : TEXCOORD0;
	float4 tc1 : TEXCOORD1;
	float4 tc2 : TEXCOORD2;
	float4 tc3 : TEXCOORD3;
	float4 tc4 : TEXCOORD4;
	float4 tc5 : TEXCOORD5;
	float4 tc6 : TEXCOORD6;
	float4 tc7 : TEXCOORD7;
	float4 tc8 : TEXCOORD8;
};

struct PixelOutput
{
	float4 ocol0 : SV_TARGET0;
	float4 ocol1 : SV_TARGET1;
	float4 ocol2 : SV_TARGET2;
	float4 ocol3 : SV_TARGET3;
};

float4 divsq_legacy(float4 num, float4 denum)
{
	return num / sqrt(max(denum.xxxx, 1.E-10));
}
float4 rcp_legacy(float4 denum)
{
	return 1. / denum;
}
float4 rsq_legacy(float4 val)
{
	return float(1.0 / sqrt(max(val.x, 1.E-10))).xxxx;
}

float4 log2_legacy(float4 val)
{
	return log2(max(val.x, 1.E-10)).xxxx;
}

float4 lit_legacy(float4 val){
	float4 clamped_val = val;
	clamped_val.x = max(val.x, 0);
	clamped_val.y = max(val.y, 0);
	float4 result;
	result.x = 1.0;
	result.w = 1.;
	result.y = clamped_val.x;
	result.z = clamped_val.x > 0.0 ? exp(clamped_val.w * log(max(clamped_val.y, 1.E-10))) : 0.0;
	return result;
}

void ps_impl(bool is_front_face, PixelInput In, inout float4 r0, inout float4 h0, inout float4 r1, inout float4 h2, inout float4 r2, inout float4 h4, inout float4 r3, inout float4 h6, inout float4 r4, inout float4 h8)
{
	float4 tc1 = In.tc1;
	float4 tc0 = In.tc0;
	float4 tc3 = In.tc3;
	float4 tc2 = In.tc2;
	float4 tc4 = In.tc4;
	float4 tc5 = In.tc5;
	float4 gl_FragCoord = In.Position;
	gl_FragCoord.y = (720 - gl_FragCoord.y);
	float4 ssa = is_front_face ? float4(1., 1., 1., 1.) : float4(-1., -1., -1., -1.);
	float4 h3 = float4(0., 0., 0., 0.);
	float4 cc0 = float4(0., 0., 0., 0.);
	float4 h11 = float4(0., 0., 0., 0.);
	float4 r5 = float4(0., 0., 0., 0.);
	float2  tex0_scale = float2(1., 1.);
	float2  tex1_scale = float2(1., 1.);
	float2  tex3_scale = float2(1., 1.);
	float2  tex4_scale = float2(1., 1.);
	float2  tex5_scale = float2(1., 1.);
	r0.yw = tex0.Sample(tex0sampler, tc1.zwzz.xy * tex0_scale).yw;
	h2.z = fc32.xxxx.z;
	h3.xy = (r0.wyzw * fc64.yyyy + fc64.zzzz).xy;
	r3.yzw = tc0.yzw;
	r0.xyz = (r3.zzzz * fc112).xyz;
	r0.xyz = (r3.yyyy * fc144 + r0).xyz;
	cc0.w = ssa.xxxx.w;
	r0.xyz = (r3.wwww * fc192 + r0).xyz;
	r2.yw = tex1.Sample(tex1sampler, tc1.xy * tex1_scale).yw;
	h3.z = fc240.xxxx.z;
	h2.xy = (r2.wyzw * fc272.yyyy + fc272.zzzz).xy;
	h2.w = dot(h3.xyz, h3.xyz).xxxx.w;
	h2.z = dot(h2.xyz, h2.xyz).xxxx.z;
	h11.zw = divsq_legacy(h3.xxxy, h2.wwww).zw;
	r4.xy = gl_FragCoord.xy;
	r5.xyz = (r0 + fc368).xyz;
	r0 = (r5.yyyy * fc400);
	r0 = (r5.xxxx * fc432 + r0);
	h2.xy = divsq_legacy(h2, h2.zzzz).xy;
	r2.xy = (h11.zwzz + h2).xy;
	r1 = (r5.zzzz * fc496 + r0);
	r1 = (r1 + fc528);
	r4.zw = (r2.xxxy * fc560.xxxx).zw;
	r3.xy = tex3.Sample(tex3sampler, (r1.xy / r1.w) * tex3_scale).xy;
	r3.xy = (r3 * fc608.xxxx + fc608.yyyy).xy;
	r0.xyz = (r2.yyyy * tc3).xyz;
	r2.xyz = (r2.xxxx * tc2 + r0).xyz;
	r2.w = dot(r3.xy, r3.xy).xxxx.w;
	r4.zw = r4.zw;
	r0.zw = (r1.xxxy + r4).zw;
	r0.xy = (r0.zwzz / r1.wwww.xxxx).xy;
	r0.xyz = tex4.Sample(tex4sampler, r0.xy * tex4_scale).xyz;
	r0.xyz = (r0 * fc768.xxxx + fc768.yyyy).xyz;
	r0.w = (-r2 + fc800.zzzz).w;
	r3.z = divsq_legacy(abs(r0.wwww), r0.wwww).z;
	r0.xyz = floor(r0).xyz;
	r2.w = dot(r0.xyz, fc864.xyz).xxxx.w;
	r0 = (r4.yyyy * fc896);
	r0 = (r4.xxxx * fc928 + r0);
	r0 = (r2.wwww * fc960 + r0);
	r0 = (r0 + fc992);
	r4.xy = r4.zwzz.xy;
	r2.w = tc0.xxxx.w;
	r3.xyz = r3.xyz;
	r3.w = dot(r5.xyz, r3.xyz).xxxx.w;
	r0.xyz = (r0 / r0.wwww.xxxx).xyz;
	r0.w = fc1104.xxxx.w;
	r0.w = dot(r0, r3).xxxx.w;
	r0.xyz = tc4.xyz;
	cc0.x = float4((r0.wwww < fc1168.xxxx)).x;
	r2.xyz = (r0 * fc1200.xxxx + r2).xyz;
	r0.w = dot(r2.xyz, r2.xyz).xxxx.w;
	r2.xyz = divsq_legacy(r2, r0.wwww).xyz;
	if ((cc0.xxxx == float4(0., 0., 0., 0.)).x) r4.xy.x = fc1264.xxxx.xy.x;
	if ((cc0.xxxx == float4(0., 0., 0., 0.)).y) r4.xy.y = fc1264.xxxx.xy.y;
	r3.xyz = tc5.xyz;
	r0.w = (r2 * fc1312).w;
	r3.w = (dot(r2.xyz, r3.xyz).xxxx * 2.0).w;
	r2.xyz = (-r2 * r3.wwww + r3).xyz;
	r2.xyz = tex2.Sample(tex2sampler, -r2.xyz).xyz;
	r1.xy = (r1 + r4).xy;
	r1.xyz = tex5.Sample(tex5sampler, (r1.xy / r1.w) * tex5_scale).xyz;
	r1.w = fc1424.yyyy.w;
	r2.xyz = (r2 * fc1456.xxxx).xyz;
	r2.xyz = (r2 * r1).xyz;
	if ((cc0.wwww >= float4(0., 0., 0., 0.)).x) r1.w = fc1504.xxxx.w;
	r1.xyz = (r2 * fc1536.xxxx + r1).xyz;
	r0.xyz = (r1.wwww * r0).xyz;
	r1.xyz = (r1 * fc1584).xyz;
	r0.xyz = tex6.Sample(tex6sampler, r0.xyz).xyz;
	r0.xyz = (r0 * fc1632 + r1).xyz;
	r0.xyz = (r0 * fc1664 + r1).xyz;
	r1.xyz = (-r0 + fc1696).xyz;
	r0.xyz = (r0.wwww * r1 + r0).xyz;
	r0.w = fc1760.xxxx.w;

}

PixelOutput main(PixelInput In, bool is_front_face : SV_IsFrontFace)
{
	float4 r0 = float4(0., 0., 0., 0.);
	float4 r1 = float4(0., 0., 0., 0.);
	float4 r2 = float4(0., 0., 0., 0.);
	float4 r3 = float4(0., 0., 0., 0.);
	float4 r4 = float4(0., 0., 0., 0.);
	float4 h0 = float4(0., 0., 0., 0.);
	float4 h2 = float4(0., 0., 0., 0.);
	float4 h4 = float4(0., 0., 0., 0.);
	float4 h6 = float4(0., 0., 0., 0.);
	float4 h8 = float4(0., 0., 0., 0.);
	ps_impl(is_front_face, In, r0, h0, r1, h2, r2, h4, r3, h6, r4, h8);
	PixelOutput Out = (PixelOutput)0;
	Out.ocol0 = r0;
	Out.ocol1 = r2;
	Out.ocol2 = r3;
	Out.ocol3 = r4;
	if (isAlphaTested && Out.ocol0.a <= alphaRef) discard;
	return Out;
}
