cbuffer SCALE_OFFSET : register(b0)
{
	float4x4 scaleOffsetMat;
	int isAlphaTested;
	float alphaRef;
};
Buffer<int4> in_pos_buffer : register(t0);
Buffer<float4> in_weight_buffer : register(t1);
Buffer<int4> in_normal_buffer : register(t2);
Buffer<int4> in_diff_color_buffer : register(t3);
Buffer<int4> in_spec_color_buffer : register(t4);
Buffer<int4> in_fog_buffer : register(t5);
Buffer<int4> in_point_size_buffer : register(t6);

struct PixelInput
{
	float4 dst_reg0 : SV_POSITION;
	float4 dst_reg1 : COLOR0;
	float4 dst_reg2 : COLOR1;
	float4 dst_reg3 : COLOR2;
	float4 dst_reg4 : COLOR3;
	float dst_reg5 : FOG;
	float4 dst_reg6 : TEXCOORD9;
	float4 dst_reg7 : TEXCOORD0;
	float4 dst_reg8 : TEXCOORD1;
	float4 dst_reg9 : TEXCOORD2;
	float4 dst_reg10 : TEXCOORD3;
	float4 dst_reg11 : TEXCOORD4;
	float4 dst_reg12 : TEXCOORD5;
	float4 dst_reg13 : TEXCOORD6;
	float4 dst_reg14 : TEXCOORD7;
	float4 dst_reg15 : TEXCOORD8;
};

cbuffer CONSTANT_BUFFER : register(b1)
{
	float4 vc[468];
};

float4 divsq_legacy(float4 num, float4 denum)
{
	return num / sqrt(max(denum.xxxx, 1.E-10));
}
float4 rcp_legacy(float4 denum)
{
	return 1. / denum;
}
float4 rsq_legacy(float4 val)
{
	return float(1.0 / sqrt(max(val.x, 1.E-10))).xxxx;
}

float4 log2_legacy(float4 val)
{
	return log2(max(val.x, 1.E-10)).xxxx;
}

float4 lit_legacy(float4 val){
	float4 clamped_val = val;
	clamped_val.x = max(val.x, 0);
	clamped_val.y = max(val.y, 0);
	float4 result;
	result.x = 1.0;
	result.w = 1.;
	result.y = clamped_val.x;
	result.z = clamped_val.x > 0.0 ? exp(clamped_val.w * log(max(clamped_val.y, 1.E-10))) : 0.0;
	return result;
}

PixelInput main(uint vertex_id : SV_VertexID)
{
	float4 tmp3 = float4(0., 0., 0., 0.);;
	float4 tmp2 = float4(0., 0., 0., 0.);;
	float4 tmp1 = float4(0., 0., 0., 0.);;
	float4 tmp0 = float4(0., 0., 0., 0.);;
	float4 dst_reg7 = float4(0.0, 0.0, 0.0, 0.0);
	float4 tmp4 = float4(0., 0., 0., 0.);;
	float4 tmp5 = float4(0., 0., 0., 0.);;
	float4 dst_reg9 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg10 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg11 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg8 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg0 = float4(0.0f, 0.0f, 0.0f, 1.0f);
	float4 in_normal = in_normal_buffer[vertex_id];
	float4 in_pos = in_pos_buffer[vertex_id];
	float4 in_spec_color = in_spec_color_buffer[vertex_id];
	float4 in_fog = in_fog_buffer[vertex_id];
	float4 in_point_size = in_point_size_buffer[vertex_id];
	float4 in_weight = in_weight_buffer[vertex_id];
	float4 in_diff_color = in_diff_color_buffer[vertex_id];
	tmp3.xyz = (in_normal.xyzx * vc[464].zzzz + -vc[464].wwww).xyz;
	tmp2.xyz = (in_pos.xyzx * vc[464].zzzz + -vc[464].wwww).xyz;
	tmp1.xyz = (in_spec_color.xyzx * vc[464].zzzz + -vc[464].wwww).xyz;
	tmp0.zw = in_fog.xxxy.zw;
	tmp0.xy = in_point_size.xyxx.xy;
	tmp1.w = (in_weight.yyyy * vc[467].xxxx).w;
	tmp2.w = vc[465].xxxx.w;
	dst_reg7 = (tmp0 * vc[464].yyyy);
	tmp0.w = (tmp2.wwww * vc[463].xxxx).w;
	tmp0.xyz = (tmp1.yyyy * vc[257].xyzx).xyz;
	tmp4.xyz = (tmp2.yyyy * vc[257].xyzx).xyz;
	tmp0.w = float4(sin(tmp0.wwww)).w;
	tmp5.xyz = (tmp3.yyyy * vc[257].xyzx).xyz;
	tmp5.xyz = (tmp3.xxxx * vc[256].xyzx + tmp5.xyzx).xyz;
	tmp4.xyz = (tmp2.xxxx * vc[256].xyzx + tmp4.xyzx).xyz;
	tmp0.xyz = (tmp1.xxxx * vc[256].xyzx + tmp0.xyzx).xyz;
	dst_reg9.xyz = (tmp1.zzzz * vc[258].xyzx + tmp0.xyzx).xyz;
	dst_reg10.xyz = (tmp2.zzzz * vc[258].xyzx + tmp4.xyzx).xyz;
	dst_reg11.xyz = (tmp3.zzzz * vc[258].xyzx + tmp5.xyzx).xyz;
	tmp0.x = (tmp0.wwww * vc[466].xxxx).x;
	tmp0.w = (tmp0.xxxx * tmp1.wwww).w;
	tmp0.xyz = (in_diff_color.xyzx * vc[464].xxxx + tmp0.wwww).xyz;
	dst_reg8.xyz = tmp0.wwww.xyz;
	tmp1 = (tmp0.yyyy * vc[261]);
	tmp1 = (tmp0.xxxx * vc[260] + tmp1);
	tmp0 = (tmp0.zzzz * vc[262] + tmp1);
	dst_reg0 = (vc[263] + tmp0);

	PixelInput Out = (PixelInput)0;
	Out.dst_reg0 = dst_reg0;
	Out.dst_reg7 = dst_reg7;
	Out.dst_reg8 = dst_reg8;
	Out.dst_reg9 = dst_reg9;
	Out.dst_reg10 = dst_reg10;
	Out.dst_reg11 = dst_reg11;
	Out.dst_reg0 = mul(Out.dst_reg0, scaleOffsetMat);
	return Out;
}
