cbuffer SCALE_OFFSET : register(b0)
{
	float4x4 scaleOffsetMat;
	int isAlphaTested;
	float alphaRef;
};
Buffer<float4> in_pos_buffer : register(t0);
Buffer<float4> in_weight_buffer : register(t1);
Buffer<float4> in_normal_buffer : register(t2);
Buffer<float4> in_diff_color_buffer : register(t3);
Buffer<float4> in_spec_color_buffer : register(t4);
Buffer<float4> in_fog_buffer : register(t5);
Buffer<float4> in_point_size_buffer : register(t6);
Buffer<float4> in_7_buffer : register(t7);
Buffer<float4> in_tc0_buffer : register(t8);
Buffer<float4> in_tc1_buffer : register(t9);
Buffer<float4> in_tc2_buffer : register(t10);
Buffer<float4> in_tc3_buffer : register(t11);

struct PixelInput
{
	float4 dst_reg0 : SV_POSITION;
	float4 dst_reg1 : COLOR0;
	float4 dst_reg2 : COLOR1;
	float4 dst_reg3 : COLOR2;
	float4 dst_reg4 : COLOR3;
	float dst_reg5 : FOG;
	float4 dst_reg6 : TEXCOORD9;
	float4 dst_reg7 : TEXCOORD0;
	float4 dst_reg8 : TEXCOORD1;
	float4 dst_reg9 : TEXCOORD2;
	float4 dst_reg10 : TEXCOORD3;
	float4 dst_reg11 : TEXCOORD4;
	float4 dst_reg12 : TEXCOORD5;
	float4 dst_reg13 : TEXCOORD6;
	float4 dst_reg14 : TEXCOORD7;
	float4 dst_reg15 : TEXCOORD8;
};

cbuffer CONSTANT_BUFFER : register(b1)
{
	float4 vc[468];
};

float4 divsq_legacy(float4 num, float4 denum)
{
	return num / sqrt(max(denum.xxxx, 1.E-10));
}
float4 rcp_legacy(float4 denum)
{
	return 1. / denum;
}
float4 rsq_legacy(float4 val)
{
	return float(1.0 / sqrt(max(val.x, 1.E-10))).xxxx;
}

float4 log2_legacy(float4 val)
{
	return log2(max(val.x, 1.E-10)).xxxx;
}

float4 lit_legacy(float4 val){
	float4 clamped_val = val;
	clamped_val.x = max(val.x, 0);
	clamped_val.y = max(val.y, 0);
	float4 result;
	result.x = 1.0;
	result.w = 1.;
	result.y = clamped_val.x;
	result.z = clamped_val.x > 0.0 ? exp(clamped_val.w * log(max(clamped_val.y, 1.E-10))) : 0.0;
	return result;
}

PixelInput main(uint vertex_id : SV_VertexID)
{
	float4 dst_reg11 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg12 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg13 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg14 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg15 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg6 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg7 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg8 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg9 = float4(0.0, 0.0, 0.0, 0.0);
	float4 tmp2 = float4(0., 0., 0., 0.);;
	float4 tmp1 = float4(0., 0., 0., 0.);;
	float4 tmp0 = float4(0., 0., 0., 0.);;
	float4 dst_reg10 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg0 = float4(0.0f, 0.0f, 0.0f, 1.0f);
	float4 in_normal = in_normal_buffer[vertex_id];
	float4 in_diff_color = in_diff_color_buffer[vertex_id];
	float4 in_spec_color = in_spec_color_buffer[vertex_id];
	float4 in_fog = in_fog_buffer[vertex_id];
	float4 in_point_size = in_point_size_buffer[vertex_id];
	float4 in_7 = in_7_buffer[vertex_id];
	float4 in_tc3 = in_tc3_buffer[vertex_id];
	float4 in_tc1 = in_tc1_buffer[vertex_id];
	float4 in_pos = in_pos_buffer[vertex_id];
	float4 in_tc2 = in_tc2_buffer[vertex_id];
	float4 in_tc0 = in_tc0_buffer[vertex_id];
	float4 in_weight = in_weight_buffer[vertex_id];
	dst_reg11 = (in_normal * vc[467].yyyy);
	dst_reg12 = (in_diff_color * vc[467].yyyy);
	dst_reg13 = (in_spec_color * vc[467].yyyy);
	dst_reg14 = (in_fog * vc[467].yyyy);
	dst_reg15 = (in_point_size * vc[467].yyyy);
	dst_reg6 = (in_7 * vc[467].yyyy);
	dst_reg7.xyz = (in_tc3.xyzx * vc[467].zzzz + -vc[467].wwww).xyz;
	dst_reg8.xyz = (in_tc1.xyzx * vc[467].zzzz + -vc[467].wwww).xyz;
	dst_reg9.xyz = (in_pos.xyzx * vc[467].zzzz + -vc[467].wwww).xyz;
	tmp2.xyz = (in_tc2.xyzx * vc[467].xxxx).xyz;
	tmp1.xyz = (in_tc0.xyzx * vc[467].yyyy).xyz;
	tmp0.xyz = in_weight.xyzx.xyz;
	tmp0.w = in_tc0.wwww.w;
	dst_reg10 = (tmp0 * vc[467].yyyy);
	dst_reg7.w = tmp1.xxxx.w;
	dst_reg8.w = tmp1.yyyy.w;
	dst_reg9.w = tmp1.zzzz.w;
	tmp0 = (tmp2.yyyy * vc[257]);
	tmp0 = (tmp2.xxxx * vc[256] + tmp0);
	tmp0 = (tmp2.zzzz * vc[258] + tmp0);
	dst_reg0 = (vc[259] + tmp0);

	PixelInput Out = (PixelInput)0;
	Out.dst_reg0 = dst_reg0;
	Out.dst_reg6 = dst_reg6;
	Out.dst_reg7 = dst_reg7;
	Out.dst_reg8 = dst_reg8;
	Out.dst_reg9 = dst_reg9;
	Out.dst_reg10 = dst_reg10;
	Out.dst_reg11 = dst_reg11;
	Out.dst_reg12 = dst_reg12;
	Out.dst_reg13 = dst_reg13;
	Out.dst_reg14 = dst_reg14;
	Out.dst_reg15 = dst_reg15;
	Out.dst_reg0 = mul(Out.dst_reg0, scaleOffsetMat);
	return Out;
}
