cbuffer SCALE_OFFSET : register(b0)
{
	float4x4 scaleOffsetMat;
	int isAlphaTested;
	float alphaRef;
};
Buffer<float4> in_pos_buffer : register(t0);
Buffer<float4> in_weight_buffer : register(t1);

struct PixelInput
{
	float4 dst_reg0 : SV_POSITION;
	float4 dst_reg1 : COLOR0;
	float4 dst_reg2 : COLOR1;
	float4 dst_reg3 : COLOR2;
	float4 dst_reg4 : COLOR3;
	float dst_reg5 : FOG;
	float4 dst_reg6 : TEXCOORD9;
	float4 dst_reg7 : TEXCOORD0;
	float4 dst_reg8 : TEXCOORD1;
	float4 dst_reg9 : TEXCOORD2;
	float4 dst_reg10 : TEXCOORD3;
	float4 dst_reg11 : TEXCOORD4;
	float4 dst_reg12 : TEXCOORD5;
	float4 dst_reg13 : TEXCOORD6;
	float4 dst_reg14 : TEXCOORD7;
	float4 dst_reg15 : TEXCOORD8;
};

cbuffer CONSTANT_BUFFER : register(b1)
{
	float4 vc[468];
};

float4 divsq_legacy(float4 num, float4 denum)
{
	return num / sqrt(max(denum.xxxx, 1.E-10));
}
float4 rcp_legacy(float4 denum)
{
	return 1. / denum;
}
float4 rsq_legacy(float4 val)
{
	return float(1.0 / sqrt(max(val.x, 1.E-10))).xxxx;
}

float4 log2_legacy(float4 val)
{
	return log2(max(val.x, 1.E-10)).xxxx;
}

float4 lit_legacy(float4 val){
	float4 clamped_val = val;
	clamped_val.x = max(val.x, 0);
	clamped_val.y = max(val.y, 0);
	float4 result;
	result.x = 1.0;
	result.w = 1.;
	result.y = clamped_val.x;
	result.z = clamped_val.x > 0.0 ? exp(clamped_val.w * log(max(clamped_val.y, 1.E-10))) : 0.0;
	return result;
}

PixelInput main(uint vertex_id : SV_VertexID)
{
	float4 tmp1 = float4(0., 0., 0., 0.);;
	float4 tmp6 = float4(0., 0., 0., 0.);;
	float4 tmp3 = float4(0., 0., 0., 0.);;
	float4 tmp2 = float4(0., 0., 0., 0.);;
	float4 tmp4 = float4(0., 0., 0., 0.);;
	float4 tmp5 = float4(0., 0., 0., 0.);;
	float4 tmp0 = float4(0., 0., 0., 0.);;
	float4 dst_reg8 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg10 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg7 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg11 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg0 = float4(0.0f, 0.0f, 0.0f, 1.0f);
	float4 dst_reg9 = float4(0.0, 0.0, 0.0, 0.0);
	float4 in_pos = in_pos_buffer[vertex_id];
	float4 in_weight = in_weight_buffer[vertex_id];
	tmp1.xyz = vc[465].xzwx.xyz;
	tmp6.xyz = (in_pos.xyzx * vc[467].xxxx).xyz;
	tmp3.xy = (in_weight.xyxx * vc[467].yyyy).xy;
	tmp3.w = vc[465].yyyy.w;
	tmp2.w = vc[465].yyyy.w;
	tmp4.y = vc[465].yyyy.y;
	tmp1.w = vc[465].yyyy.w;
	tmp4.w = vc[465].yyyy.w;
	tmp5.y = vc[465].yyyy.y;
	tmp2.x = vc[466].xxxx.x;
	tmp0.x = vc[466].xxxx.x;
	tmp0.y = vc[465].yyyy.y;
	tmp0.z = -vc[466].xxxx.z;
	tmp0.w = vc[465].yyyy.w;
	dst_reg8.xy = (tmp3.xyxx + tmp0.zwzz).xy;
	dst_reg10.xy = (tmp3.xyxx + tmp0.xyxx).xy;
	tmp0 = (tmp6.yyyy * vc[257]);
	tmp1.xyz = (tmp1.xyzx * vc[466].xxxx).xyz;
	tmp2.xyz = (tmp2.xxxx * vc[464].xyzx).xyz;
	tmp0 = (tmp6.xxxx * vc[256] + tmp0);
	tmp3.z = tmp2.xxxx.z;
	tmp4.x = tmp2.yyyy.x;
	tmp4.z = tmp1.yyyy.z;
	tmp5.x = tmp1.xxxx.x;
	tmp0 = (tmp6.zzzz * vc[258] + tmp0);
	dst_reg7.zw = (tmp3.xxxy + tmp5.xxxy).zw;
	dst_reg7.xy = (tmp3.xyxx + tmp4.zwzz).xy;
	dst_reg8.zw = (tmp3.xxxy + tmp1.zzzw).zw;
	dst_reg10.zw = (tmp3.xxxy + tmp4.xxxy).zw;
	dst_reg11.xy = (tmp3.xyxx + tmp2.zwzz).xy;
	tmp3.zw = (tmp3.xxxy + tmp3.zzzw).zw;
	dst_reg0 = (vc[259] + tmp0);
	dst_reg9 = tmp3;

	PixelInput Out = (PixelInput)0;
	Out.dst_reg0 = dst_reg0;
	Out.dst_reg7 = dst_reg7;
	Out.dst_reg8 = dst_reg8;
	Out.dst_reg9 = dst_reg9;
	Out.dst_reg10 = dst_reg10;
	Out.dst_reg11 = dst_reg11;
	Out.dst_reg0 = mul(Out.dst_reg0, scaleOffsetMat);
	return Out;
}
