cbuffer SCALE_OFFSET : register(b0)
{
	float4x4 scaleOffsetMat;
	int isAlphaTested;
	float alphaRef;
};
Buffer<int4> in_pos_buffer : register(t0);
Buffer<int4> in_weight_buffer : register(t1);
Buffer<int4> in_normal_buffer : register(t2);
Buffer<int4> in_diff_color_buffer : register(t3);
Buffer<int4> in_spec_color_buffer : register(t4);

struct PixelInput
{
	float4 dst_reg0 : SV_POSITION;
	float4 dst_reg1 : COLOR0;
	float4 dst_reg2 : COLOR1;
	float4 dst_reg3 : COLOR2;
	float4 dst_reg4 : COLOR3;
	float dst_reg5 : FOG;
	float4 dst_reg6 : TEXCOORD9;
	float4 dst_reg7 : TEXCOORD0;
	float4 dst_reg8 : TEXCOORD1;
	float4 dst_reg9 : TEXCOORD2;
	float4 dst_reg10 : TEXCOORD3;
	float4 dst_reg11 : TEXCOORD4;
	float4 dst_reg12 : TEXCOORD5;
	float4 dst_reg13 : TEXCOORD6;
	float4 dst_reg14 : TEXCOORD7;
	float4 dst_reg15 : TEXCOORD8;
};

cbuffer CONSTANT_BUFFER : register(b1)
{
	float4 vc[468];
};

float4 divsq_legacy(float4 num, float4 denum)
{
	return num / sqrt(max(denum.xxxx, 1.E-10));
}
float4 rcp_legacy(float4 denum)
{
	return 1. / denum;
}
float4 rsq_legacy(float4 val)
{
	return float(1.0 / sqrt(max(val.x, 1.E-10))).xxxx;
}

float4 log2_legacy(float4 val)
{
	return log2(max(val.x, 1.E-10)).xxxx;
}

float4 lit_legacy(float4 val){
	float4 clamped_val = val;
	clamped_val.x = max(val.x, 0);
	clamped_val.y = max(val.y, 0);
	float4 result;
	result.x = 1.0;
	result.w = 1.;
	result.y = clamped_val.x;
	result.z = clamped_val.x > 0.0 ? exp(clamped_val.w * log(max(clamped_val.y, 1.E-10))) : 0.0;
	return result;
}

PixelInput main(uint vertex_id : SV_VertexID)
{
	float4 tmp1 = float4(0., 0., 0., 0.);;
	float4 tmp3 = float4(0., 0., 0., 0.);;
	float4 tmp4 = float4(0., 0., 0., 0.);;
	float4 tmp8 = float4(0., 0., 0., 0.);;
	float4 dst_reg7 = float4(0.0, 0.0, 0.0, 0.0);
	float4 tmp0 = float4(0., 0., 0., 0.);;
	float4 tmp2 = float4(0., 0., 0., 0.);;
	float4 tmp5 = float4(0., 0., 0., 0.);;
	float4 tmp6 = float4(0., 0., 0., 0.);;
	float4 tmp7 = float4(0., 0., 0., 0.);;
	float4 dst_reg8 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg9 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg10 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg11 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg12 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg0 = float4(0.0f, 0.0f, 0.0f, 1.0f);
	float4 in_weight = in_weight_buffer[vertex_id];
	float4 in_pos = in_pos_buffer[vertex_id];
	float4 in_diff_color = in_diff_color_buffer[vertex_id];
	float4 in_normal = in_normal_buffer[vertex_id];
	float4 in_spec_color = in_spec_color_buffer[vertex_id];
	tmp1.xyz = (in_weight.xyzx * vc[465].zzzz + -vc[465].wwww).xyz;
	tmp3.xyz = (in_pos.xyzx * vc[465].zzzz + -vc[465].wwww).xyz;
	tmp4.xyz = (in_diff_color.xyzx * vc[465].zzzz + -vc[465].wwww).xyz;
	tmp8.xyz = (in_normal.xyzx * vc[465].xxxx).xyz;
	dst_reg7.yz = (in_spec_color.xxyx * vc[465].yyyy).yz;
	tmp0 = (tmp8.yyyy * vc[257]);
	tmp2.xyz = (vc[467].xyzx + -tmp8.xyzx).xyz;
	tmp0 = (tmp8.xxxx * vc[256] + tmp0);
	tmp5.xyz = (tmp4.yyyy * vc[261].xyzx).xyz;
	tmp6.xyz = (tmp3.yyyy * vc[261].xyzx).xyz;
	tmp7.xyz = (tmp1.yyyy * vc[261].xyzx).xyz;
	dst_reg8.z = dot(tmp1.xyzx.xyz, tmp2.xyzx.xyz).xxxx.z;
	dst_reg8.y = dot(tmp2.xyzx.xyz, tmp3.xyzx.xyz).xxxx.y;
	dst_reg8.x = dot(tmp2.xyzx.xyz, tmp4.xyzx.xyz).xxxx.x;
	tmp0 = (tmp8.zzzz * vc[258] + tmp0);
	tmp7.xyz = (tmp1.xxxx * vc[260].xyzx + tmp7.xyzx).xyz;
	tmp6.xyz = (tmp3.xxxx * vc[260].xyzx + tmp6.xyzx).xyz;
	tmp5.xyz = (tmp4.xxxx * vc[260].xyzx + tmp5.xyzx).xyz;
	tmp8.xyz = (tmp2.yyyy * vc[261].xyzx).xyz;
	dst_reg9.xyz = (tmp4.zzzz * vc[262].xyzx + tmp5.xyzx).xyz;
	dst_reg10.xyz = (tmp3.zzzz * vc[262].xyzx + tmp6.xyzx).xyz;
	dst_reg11.xyz = (tmp1.zzzz * vc[262].xyzx + tmp7.xyzx).xyz;
	tmp1.xyz = (tmp2.xxxx * vc[260].xyzx + tmp8.xyzx).xyz;
	tmp0 = (vc[259] + tmp0);
	dst_reg12.xyz = (tmp2.zzzz * vc[262].xyzx + tmp1.xyzx).xyz;
	tmp1.x = (-vc[466].xxxx + tmp0.zzzz).x;
	dst_reg0 = tmp0;
	dst_reg7.x = clamp((tmp1.xxxx * vc[466].yyyy).x, 0.0, 1.0);

	PixelInput Out = (PixelInput)0;
	Out.dst_reg0 = dst_reg0;
	Out.dst_reg7 = dst_reg7;
	Out.dst_reg8 = dst_reg8;
	Out.dst_reg9 = dst_reg9;
	Out.dst_reg10 = dst_reg10;
	Out.dst_reg11 = dst_reg11;
	Out.dst_reg12 = dst_reg12;
	Out.dst_reg0 = mul(Out.dst_reg0, scaleOffsetMat);
	return Out;
}
