cbuffer SCALE_OFFSET : register(b0)
{
	float4x4 scaleOffsetMat;
	int isAlphaTested;
	float alphaRef;
};
Buffer<int4> in_pos_buffer : register(t0);
Buffer<int4> in_weight_buffer : register(t1);
Buffer<int4> in_normal_buffer : register(t2);
Buffer<int4> in_diff_color_buffer : register(t3);
Buffer<int4> in_spec_color_buffer : register(t4);
Buffer<int4> in_fog_buffer : register(t5);

struct PixelInput
{
	float4 dst_reg0 : SV_POSITION;
	float4 dst_reg1 : COLOR0;
	float4 dst_reg2 : COLOR1;
	float4 dst_reg3 : COLOR2;
	float4 dst_reg4 : COLOR3;
	float dst_reg5 : FOG;
	float4 dst_reg6 : TEXCOORD9;
	float4 dst_reg7 : TEXCOORD0;
	float4 dst_reg8 : TEXCOORD1;
	float4 dst_reg9 : TEXCOORD2;
	float4 dst_reg10 : TEXCOORD3;
	float4 dst_reg11 : TEXCOORD4;
	float4 dst_reg12 : TEXCOORD5;
	float4 dst_reg13 : TEXCOORD6;
	float4 dst_reg14 : TEXCOORD7;
	float4 dst_reg15 : TEXCOORD8;
};

cbuffer CONSTANT_BUFFER : register(b1)
{
	float4 vc[468];
};

float4 divsq_legacy(float4 num, float4 denum)
{
	return num / sqrt(max(denum.xxxx, 1.E-10));
}
float4 rcp_legacy(float4 denum)
{
	return 1. / denum;
}
float4 rsq_legacy(float4 val)
{
	return float(1.0 / sqrt(max(val.x, 1.E-10))).xxxx;
}

float4 log2_legacy(float4 val)
{
	return log2(max(val.x, 1.E-10)).xxxx;
}

float4 lit_legacy(float4 val){
	float4 clamped_val = val;
	clamped_val.x = max(val.x, 0);
	clamped_val.y = max(val.y, 0);
	float4 result;
	result.x = 1.0;
	result.w = 1.;
	result.y = clamped_val.x;
	result.z = clamped_val.x > 0.0 ? exp(clamped_val.w * log(max(clamped_val.y, 1.E-10))) : 0.0;
	return result;
}

PixelInput main(uint vertex_id : SV_VertexID)
{
	float4 tmp8 = float4(0., 0., 0., 0.);;
	float4 tmp9 = float4(0., 0., 0., 0.);;
	float4 tmp10 = float4(0., 0., 0., 0.);;
	float4 tmp11 = float4(0., 0., 0., 0.);;
	float4 tmp0 = float4(0., 0., 0., 0.);;
	float4 dst_reg7 = float4(0.0, 0.0, 0.0, 0.0);
	float4 tmp1 = float4(0., 0., 0., 0.);;
	float4 tmp2 = float4(0., 0., 0., 0.);;
	float4 tmp5 = float4(0., 0., 0., 0.);;
	float4 tmp3 = float4(0., 0., 0., 0.);;
	float4 tmp6 = float4(0., 0., 0., 0.);;
	float4 tmp4 = float4(0., 0., 0., 0.);;
	float4 tmp7 = float4(0., 0., 0., 0.);;
	float4 dst_reg8 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg0 = float4(0.0f, 0.0f, 0.0f, 1.0f);
	float4 dst_reg9 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg12 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg10 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg13 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg11 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg14 = float4(0.0, 0.0, 0.0, 0.0);
	float4 dst_reg15 = float4(0.0, 0.0, 0.0, 0.0);
	float4 in_weight = in_weight_buffer[vertex_id];
	float4 in_pos = in_pos_buffer[vertex_id];
	float4 in_diff_color = in_diff_color_buffer[vertex_id];
	float4 in_normal = in_normal_buffer[vertex_id];
	float4 in_spec_color = in_spec_color_buffer[vertex_id];
	float4 in_fog = in_fog_buffer[vertex_id];
	tmp8.xyz = (in_weight.xyzx * vc[466].zzzz + -vc[466].wwww).xyz;
	tmp9.xyz = (in_pos.xyzx * vc[466].zzzz + -vc[466].wwww).xyz;
	tmp10.xyz = (in_diff_color.xyzx * vc[466].zzzz + -vc[466].wwww).xyz;
	tmp11.xyz = (in_normal.xyzx * vc[466].xxxx).xyz;
	tmp0.zw = in_spec_color.xxxy.zw;
	tmp0.xy = in_fog.xyxx.xy;
	dst_reg7 = (tmp0 * vc[466].yyyy);
	tmp0 = (tmp11.yyyy * vc[261]);
	tmp1.xyz = (vc[467].xyzx + -tmp11.xyzx).xyz;
	tmp0 = (tmp11.xxxx * vc[260] + tmp0);
	tmp2.xyz = (tmp10.yyyy * vc[257].xyzx).xyz;
	tmp5.xyz = (tmp10.yyyy * vc[265].xyzx).xyz;
	tmp3.xyz = (tmp9.yyyy * vc[257].xyzx).xyz;
	tmp6.xyz = (tmp9.yyyy * vc[265].xyzx).xyz;
	tmp4.xyz = (tmp8.yyyy * vc[257].xyzx).xyz;
	tmp7.xyz = (tmp8.yyyy * vc[265].xyzx).xyz;
	dst_reg8.z = dot(tmp8.xyzx.xyz, tmp1.xyzx.xyz).xxxx.z;
	dst_reg8.y = dot(tmp1.xyzx.xyz, tmp9.xyzx.xyz).xxxx.y;
	dst_reg8.x = dot(tmp1.xyzx.xyz, tmp10.xyzx.xyz).xxxx.x;
	tmp0 = (tmp11.zzzz * vc[262] + tmp0);
	tmp7.xyz = (tmp8.xxxx * vc[264].xyzx + tmp7.xyzx).xyz;
	tmp4.xyz = (tmp8.xxxx * vc[256].xyzx + tmp4.xyzx).xyz;
	tmp6.xyz = (tmp9.xxxx * vc[264].xyzx + tmp6.xyzx).xyz;
	tmp3.xyz = (tmp9.xxxx * vc[256].xyzx + tmp3.xyzx).xyz;
	tmp5.xyz = (tmp10.xxxx * vc[264].xyzx + tmp5.xyzx).xyz;
	tmp2.xyz = (tmp10.xxxx * vc[256].xyzx + tmp2.xyzx).xyz;
	tmp11.xyz = (tmp1.yyyy * vc[265].xyzx).xyz;
	dst_reg0 = (vc[263] + tmp0);
	dst_reg9.xyz = (tmp10.zzzz * vc[258].xyzx + tmp2.xyzx).xyz;
	dst_reg12.xyz = (tmp10.zzzz * vc[266].xyzx + tmp5.xyzx).xyz;
	dst_reg10.xyz = (tmp9.zzzz * vc[258].xyzx + tmp3.xyzx).xyz;
	dst_reg13.xyz = (tmp9.zzzz * vc[266].xyzx + tmp6.xyzx).xyz;
	dst_reg11.xyz = (tmp8.zzzz * vc[258].xyzx + tmp4.xyzx).xyz;
	dst_reg14.xyz = (tmp8.zzzz * vc[266].xyzx + tmp7.xyzx).xyz;
	tmp0.xyz = (tmp1.xxxx * vc[264].xyzx + tmp11.xyzx).xyz;
	dst_reg15.xyz = (tmp1.zzzz * vc[266].xyzx + tmp0.xyzx).xyz;

	PixelInput Out = (PixelInput)0;
	Out.dst_reg0 = dst_reg0;
	Out.dst_reg7 = dst_reg7;
	Out.dst_reg8 = dst_reg8;
	Out.dst_reg9 = dst_reg9;
	Out.dst_reg10 = dst_reg10;
	Out.dst_reg11 = dst_reg11;
	Out.dst_reg12 = dst_reg12;
	Out.dst_reg13 = dst_reg13;
	Out.dst_reg14 = dst_reg14;
	Out.dst_reg15 = dst_reg15;
	Out.dst_reg0 = mul(Out.dst_reg0, scaleOffsetMat);
	return Out;
}
